```cpp
//仅支持 2^k 修改线段树同一层的区间的修改

const int maxn = 1e6 + 10;
int rev[maxn];
ll a[maxn];
int n, q;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x,d) (x<<1)^rev[d]
#define rc(x,d) x<<1|(1^rev[d])
    struct tree
    {
        ll a;
        tree() : a(0) {}
    }node[maxn << 2];

    STtree() {}

    inline void push_up(int x, int d)
    {
        //query功能
        node[x].a = (node[lc(x, d)].a + node[rc(x, d)].a);
    }

    void build(int x, int l, int r, ll* a,int d)
    {
        if (l == r)
        {
            node[x].a = a[l];
            return;
        }
        int mid = (l + r) >> 1;
        build(lc(x, d), l, mid, a, d - 1);
        build(rc(x, d), mid + 1, r, a, d - 1);
        push_up(x, d);
    }

    void update(int l, int r, int p, int x, ll k, int d)
    {
        if (l == r)
        {
            node[x].a = k;
            return;
        }
        int mid = (l + r) >> 1;
        if (p <= mid) update(l, mid, p, lc(x, d), k, d - 1);
        else update(mid + 1, r, p, rc(x, d), k, d - 1);
        push_up(x, d);
    }

    ll query(int l, int r, int left, int right, int x, int d)
    {
        //debug(node[x].l<<" "<<node[x].r);
        //debug(right<<" "<<left);
        ll res = 0;
        if (left <= l && r <= right) return node[x].a;
        int mid = (l + r) >> 1;
        if (left <= mid) res += query(l, mid, left, right, lc(x, d), d - 1);
        if (right > mid) res += query(mid + 1, r, left, right, rc(x, d), d - 1);
        return res;
    }
}st;

int main()
{
	Design;
    cin >> n >> q;
    mfor(i, 1, 1 << n)
    {
        cin >> a[i];
    }
    st.build(1, 1, 1 << n, a, n);
    while (q--)
    {
        int op;
        cin >> op;
        if (op == 1)
        {//modfiy
            ll x, k;
            cin >> x >> k;
            st.update(1, 1 << n, x, 1, k, n);
        }
        else if (op == 2)
        {//reverse
            int k;
            cin >> k;
            mfor(i, 0, k) rev[i] ^= 1;
        }
        else if (op == 3)
        {//swap
            int k;
            cin >> k;
            rev[k + 1] ^= 1;
        }
        else
        {//sum
            int l, r;
            cin >> l >> r;
            cout << st.query(1, 1 << n, l, r, 1, n) << endl;
        }
    }
}
```

