```cpp
struct StringHash 
{
	const ull mod = 100341697;
	//备选模数 1333331 197309719 50331683
	ull pro[1000010];
	ull _hash[1000010];
	ull _revh[1000010];
	StringHash() 
	{
		init();
	}

	inline void init() 
	{
		//预处理p^(r-l+1)
		pro[0] = 1;
		for (int i = 1; i <= 1000000; i++) pro[i] = pro[i - 1] * mod;
	}

	void gethash(string s, ull base = 'a' - 1) 
	{
		//base为字符类型，如小写字母base='a'- 1
		_hash[0] = s[0] - base;
		for (size_t i = 1; i < s.length(); i++) {
			_hash[i] = _hash[i - 1] * mod;
			_hash[i] += s[i] - base;
		}
	}

	void getrevh(string s, ull base = 'a') 
	{
		_revh[s.length()] = 0;
		for (int i = (int)s.length() - 1; i >= 0; i--) {
			_revh[i] = _revh[i + 1] * mod;
			_revh[i] += s[i] - base;
		}
	}

	ull get(int l, int r) 
	{
		//获取下标L到R的hash值
		if (l == 0) return _hash[r];
		return _hash[r] - _hash[l - 1] * pro[r - l + 1];
	}

	ull ret(int l, int r)
	{
		//获取下标L到R的revh值
		return _revh[l] - _revh[r + 1] * pro[r - l + 1];
	}
};
```

