```cpp
set<ll>res; //质因子
bool np[(int)1e5 + 10];

ll gcd(ll a, ll b)
{
    if (!b) return a;
    return gcd(b, a % b);
}

void init()
{
    np[0] = true;
    np[1] = true;
    for (int i = 2; i <= 1e5; i++)
    {
        if (np[i]) continue;
        int pro = i + i;
        while (pro <= 1e5)
        {
            np[pro] = true;
            pro += i;
        }
    }
}

long long PollardRho(ll x)
{
    long long s = 0;
    long long t = 0;
    long long c = 1ll * rand() % (x - 1) + 1;
    int st = 0;
    int tar = 1;
    ll val = 1;
    while (1)
    {
        for (st = 1; st <= tar; st++)
        {
            t = ((lll)t * t + c) % x;
            val = (lll)val * abs(t - s) % x;
            if ((st % 127) == 0)
            {
                ll d = gcd(val, x);
                if (d > 1) return d;
            }
        }
        ll d = gcd(val, x);
        if (d > 1) return d;
        tar <<= 1;
        s = t;
        val = 1;
    }
}

long long fpow(long long a, long long n, long long mod)
{
    long long res = 1;
    while (n)
    {
        if (n & 1) res = (lll)res * a % mod;
        a = (lll)a * a % mod;
        n >>= 1;
    }
    return res;
}

bool MillerRabin(ll x, ll b)
{
    ll k = x - 1;
    while (k)  //费马小定理
    {
        ll t = fpow(b, k, x);
        if (t != 1 && t != x - 1) return false;
        if ((k & 1) == 1 || t == x - 1) return true;
        k >>= 1;
    }
    return true;
}

bool prime(ll x) //大概率正确得出，因为费马小定理反过来不一定成立
{
    if (x <= 1e5 && np[x]) return false;
    if (x <= 1e5 && !np[x]) return true;
    return MillerRabin(x, 29) && MillerRabin(x, 23) && MillerRabin(x, 11);  //增加质参数能使正确率提升
}

void cal(ll x)  //调用此函数进行计算
{
    if (x < 2) return;
    if (prime(x))
    {
        res.insert(x);
        return;
    }
    ll t = x;
    while (t >= x) t = PollardRho(x);
    while ((x % t) == 0) x /= t;
    cal(x);
    cal(t);
}

```

