# 面积和周长并

```cpp
struct lin
{
    ll l, r;
    ll p;
    int val;
    bool operator < (lin s)const
    {
        if (p == s.p) return val > s.val;
        return p < s.p;
    }
    lin(ll l, ll r, ll p, int v) :l(l), r(r), p(p), val(v) {}
};

vector<ll>s;
vector<lin>t;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x) x<<1
#define rc(x) x<<1|1
    struct tree
    {
        ll a;
        int l, r;
        ll hl, hr;
        ll tag;
        tree() {}
    }node[maxn << 2];

    inline void push_up(int x)
    {
        if (node[x].tag) node[x].a = node[x].hr - node[x].hl;
        else node[x].a = node[lc(x)].a + node[rc(x)].a;
    }

    void build(int x, int l, int r)
    {
        node[x].l = l;
        node[x].r = r;
        node[x].hl = s[l - 1];
        node[x].hr = s[r - 1];
        //debug(node[x].hl << " " << node[x].hr);
        node[x].tag = 0;
        //debug(x << " " << node[x].hl << " " << node[x].hr);
        if (r - l <= 1)
        {
            node[x].a = 0;
            return;
        }
        int mid = (l + r) >> 1;
        build(lc(x), l, mid);
        build(rc(x), mid, r);
        push_up(x);
    }

    void update(ll left, ll right, int x, int k)
    {
        if (left == node[x].hl && node[x].hr == right)
        {
            node[x].tag += k;
            push_up(x);
            return;
        }
        if (left < node[lc(x)].hr) update(left, min(node[lc(x)].hr, right), lc(x), k);
        if (right > node[rc(x)].hl) update(max(left, node[rc(x)].hl), right, rc(x), k);
        push_up(x);
    }

    ll getsum(int x)
    {
        return node[x].a;
    }

}st;
```

#### HDU 1828 (一堆矩形算周长)

```cpp
#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<set>
#include<list>
#include<iomanip>
#include<cstring>
#include<cmath>
#include<limits>
#include<cctype>
#include<unordered_map>
#include<complex>
#include<assert.h>
#pragma warning(disable:4996)
using namespace std;

#define debug(i) cerr<<"<debug> "<<#i<<" "<<i<<" <\\debug>"<<endl
#define mfor(i,a,b) for(int i=(a);i<=(b);i++)
#define mrep(i,a,b) for(int i=(a);i>=(b);i--)
#define _for(i,a,b) for(ll i=(a);i<=(b);i++)
#define _rep(i,a,b) for(ll i=(a);i>=(b);i--)
#define lll __int128
#define Re register
#define mem(a,b) memset(a,(b),sizeof(a))
#define Design ios::sync_with_stdio(0),cin.tie(0),cout.tie(0)
#define endl '\n'
#define toang(x) ((x)*180.0/pi)	//转角度
#define torad(x) ((x)*pi/180.0)	//转弧度
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> intpair;
typedef pair<ll, ll> llpair;
typedef long double ld;
typedef double dl;
const ld pi = acos(-1.0);
const ld eps = 1e-5;
const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

const int maxn = 1000010;

struct lin
{
    ll l, r;
    ll p;
    int val;
    bool operator < (lin s)const
    {
        if (p == s.p) return val > s.val;
        return p < s.p;
    }
    lin(ll l, ll r, ll p, int v) :l(l), r(r), p(p), val(v) {}
};

vector<ll>s;
vector<lin>t, t1;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x) x<<1
#define rc(x) x<<1|1
    struct tree
    {
        ll a;
        int l, r;
        ll hl, hr;
        ll tag;
        tree() {}
    }node[maxn << 2];

    inline void push_up(int x)
    {
        if (node[x].tag) node[x].a = node[x].hr - node[x].hl;
        else node[x].a = node[lc(x)].a + node[rc(x)].a;
    }

    void build(int x, int l, int r)
    {
        node[x].l = l;
        node[x].r = r;
        node[x].hl = s[l - 1];
        node[x].hr = s[r - 1];
        //debug(node[x].hl << " " << node[x].hr);
        node[x].tag = 0;
        //debug(x << " " << node[x].hl << " " << node[x].hr);
        if (r - l <= 1)
        {
            node[x].a = 0;
            return;
        }
        int mid = (l + r) >> 1;
        build(lc(x), l, mid);
        build(rc(x), mid, r);
        push_up(x);
    }

    void update(ll left, ll right, int x, int k)
    {
        if (left == node[x].hl && node[x].hr == right)
        {
            node[x].tag += k;
            push_up(x);
            return;
        }
        if (left < node[lc(x)].hr) update(left, min(node[lc(x)].hr, right), lc(x), k);
        if (right > node[rc(x)].hl) update(max(left, node[rc(x)].hl), right, rc(x), k);
        push_up(x);
    }

    ll getsum(int x)
    {
        return node[x].a;
    }

}st;

int main()
{
    Design;
    int n;
    int tot = 1;
    while (cin >> n)
    {
        if (!n) break;
        s.clear();
        t.clear();
        t1.clear();
        mfor(i, 1, n)
        {
            ll x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            t.emplace_back(x1, x2, y1, 1);
            t.emplace_back(x1, x2, y2, -1);
            t1.emplace_back(y1, y2, x1, 1);
            t1.emplace_back(y1, y2, x2, -1);
            s.emplace_back(x1);
            s.emplace_back(x2);
            s.emplace_back(y1);
            s.emplace_back(y2);
        }
        sort(s.begin(), s.end());
        sort(t.begin(), t.end());
        sort(t1.begin(), t1.end());
        unique(s.begin(), s.end());
        ll ans = 0;
        int now = 0;
        st.build(1, 1, s.size());
        while (now < (int)t.size())
        {
            int i = now;
            ll tmp = st.getsum(1);
            //while (t[i] == t[now])
            {
                st.update(t[i].l, t[i].r, 1, t[i].val);
                i++;
                //if (i >= (int)t.size()) break;
            }
            now = i;
            tmp = abs(st.getsum(1) - tmp);
            ans += tmp;
            //debug(tmp);
        }
        //debug(ans);
        st.build(1, 1, s.size());
        now = 0;
        while (now < (int)t1.size())
        {
            int i = now;
            ll tmp = st.getsum(1);
            //while (t1[i] == t1[now])
            {
                st.update(t1[i].l, t1[i].r, 1, t1[i].val);
                i++;
                //if (i >= (int)t1.size()) break;
            }
            now = i;
            tmp = abs(st.getsum(1) - tmp);
            ans += tmp;
        }
        //debug(ans);
        cout << ans << endl;
    }
    return 0;
}
```

#### HDU 1542(一堆矩形算面积)

```cpp
#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<set>
#include<list>
#include<iomanip>
#include<cstring>
#include<cmath>
#include<limits>
#include<cctype>
#include<unordered_map>
#include<complex>
#include<assert.h>
#pragma warning(disable:4996)
using namespace std;

#define debug(i) cerr<<"<debug> "<<#i<<" "<<i<<" <\\debug>"<<endl
#define mfor(i,a,b) for(int i=(a);i<=(b);i++)
#define mrep(i,a,b) for(int i=(a);i>=(b);i--)
#define _for(i,a,b) for(ll i=(a);i<=(b);i++)
#define _rep(i,a,b) for(ll i=(a);i>=(b);i--)
#define lll __int128
#define Re register
#define mem(a,b) memset(a,(b),sizeof(a))
#define Design ios::sync_with_stdio(0),cin.tie(0),cout.tie(0)
#define endl '\n'
#define toang(x) ((x)*180.0/pi)    //转角度
#define torad(x) ((x)*pi/180.0)    //转弧度
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> intpair;
typedef pair<ll, ll> llpair;
typedef long double ld;
typedef double dl;
const ld pi = acos(-1.0);
const ld eps = 1e-5;
const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

const int maxn = 200010;


struct lin
{
    dl l, r;
    dl p;
    int val;
    bool operator == (lin s)const
    {
        return l == s.l && r == s.r && p == s.p && val == s.val;
    }
    bool operator < (lin s)const
    {
        return p < s.p;
    }
    lin(dl l, dl r, dl p, int v) :l(l), r(r), p(p), val(v) {}
};

vector<dl>s;
vector<lin>t;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x) x<<1
#define rc(x) x<<1|1
    struct tree
    {
        dl a;
        int l, r;
        dl hl, hr;
        int tag;
        tree() {}
    }node[maxn << 2];

    inline void push_up(int x)
    {
        if (node[x].tag) node[x].a = node[x].hr - node[x].hl;
        else node[x].a = node[lc(x)].a + node[rc(x)].a;
    }

    void build(int x, int l, int r)
    {
        node[x].l = l;
        node[x].r = r;
        node[x].hl = s[l - 1];
        node[x].hr = s[r - 1];
        //debug(node[x].hl << " " << node[x].hr);
        node[x].tag = 0;
        //debug(x << " " << node[x].hl << " " << node[x].hr);
        if (r - l <= 1)
        {
            node[x].a = 0;
            return;
        }
        int mid = (l + r) >> 1;
        build(lc(x), l, mid);
        build(rc(x), mid, r);
        push_up(x);
    }

    void update(dl left, dl right, int x, int k)
    {
        if (left == node[x].hl && node[x].hr == right)
        {
            node[x].tag += k;
            push_up(x);
            return;
        }
        if (left < node[lc(x)].hr) update(left, min(node[lc(x)].hr, right), lc(x), k);
        if (right > node[rc(x)].hl) update(max(left, node[rc(x)].hl), right, rc(x), k);
        push_up(x);
    }

    dl getsum(int x)
    {
        return node[x].a;
    }

}st;

int main()
{
    //Design;
    int n;
    int tot = 1;
    while (cin >> n)
    {
        if (!n) break;
        s.clear();
        t.clear();
        mfor(i, 1, n)
        {
            dl x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            t.emplace_back(x1, x2, y1, 1);
            t.emplace_back(x1, x2, y2, -1);
            s.emplace_back(x1);
            s.emplace_back(x2);
        }
        sort(s.begin(), s.end());
        sort(t.begin(), t.end());
        dl ans = 0;
        st.build(1, 1, s.size());
        st.update(t[0].l, t[0].r, 1, t[0].val);
        //debug(t[0].l << " " << t[0].r);
        mfor(i, 1, (int)t.size() - 1)
        {
            //debug(ans);
            ans += (t[i].p - t[i - 1].p) * st.getsum(1);
            //debug(st.getsum(1));
            st.update(t[i].l, t[i].r, 1, t[i].val);
        }
        cout << "Test case #" << tot++ << endl;
        cout << "Total explored area: " << fixed << setprecision(2) << ans << endl << endl;
    }
    return 0;
}
```

#### HDU3265 （给定框，拆成四个矩形）

```cpp
#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<set>
#include<list>
#include<iomanip>
#include<cstring>
#include<cmath>
#include<limits>
#include<cctype>
#include<unordered_map>
#include<complex>
#include<assert.h>
#pragma warning(disable:4996)
using namespace std;

#define debug(i) cerr<<"<debug> "<<#i<<" "<<i<<" <\\debug>"<<endl
#define mfor(i,a,b) for(int i=(a);i<=(b);i++)
#define mrep(i,a,b) for(int i=(a);i>=(b);i--)
#define _for(i,a,b) for(ll i=(a);i<=(b);i++)
#define _rep(i,a,b) for(ll i=(a);i>=(b);i--)
#define lll __int128
#define Re register
#define mem(a,b) memset(a,(b),sizeof(a))
#define Design ios::sync_with_stdio(0),cin.tie(0),cout.tie(0)
#define endl '\n'
#define toang(x) ((x)*180.0/pi)	//转角度
#define torad(x) ((x)*pi/180.0)	//转弧度
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> intpair;
typedef pair<ll, ll> llpair;
typedef long double ld;
typedef double dl;
const ld pi = acos(-1.0);
const ld eps = 1e-5;
const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

const int maxn = 400010;

struct lin
{
    int l, r;
    int p;
    int val;
    bool operator < (lin s)const
    {
        if (p == s.p) return val > s.val;
        return p < s.p;
    }
    lin(int l, int r, int p, int v) :l(l), r(r), p(p), val(v) {}
};

vector<int>s;
vector<lin>t, t1;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x) x<<1
#define rc(x) x<<1|1
    struct tree
    {
        int a;
        int hl, hr;
        int tag;
        tree() {}
    }node[maxn << 2];

    inline void push_up(int x)
    {
        if (node[x].tag > 0) node[x].a = node[x].hr - node[x].hl;
        else node[x].a = node[lc(x)].a + node[rc(x)].a;
    }

    void build(int x, int l, int r)
    {
        node[x].hl = s[l - 1];
        node[x].hr = s[r - 1];
        node[x].tag = 0;
        if (r - l <= 1)
        {
            node[x].a = 0;
            return;
        }
        int mid = (l + r) >> 1;
        build(lc(x), l, mid);
        build(rc(x), mid, r);
        push_up(x);
    }

    void update(int left, int right, int x, int k)
    {
        if (left == node[x].hl && node[x].hr == right)
        {
            node[x].tag += k;
            push_up(x);
            return;
        }
        if (left < node[lc(x)].hr) update(left, min(node[lc(x)].hr, right), lc(x), k);
        if (right > node[rc(x)].hl) update(max(left, node[rc(x)].hl), right, rc(x), k);
        push_up(x);
    }

    ll getsum(int x)
    {
        return node[x].a;
    }

}st;

int main()
{
    Design;
    int n;
    while (cin >> n)
    {
        if (!n) break;
        s.clear();
        t.clear();
        mfor(i, 1, n)
        {
            ll x1, y1, x2, y2;
            cin >> x1 >> y1 >> x2 >> y2;
            s.emplace_back(x1);
            s.emplace_back(x2);
            ll x3, y3, x4, y4;
            cin >> x3 >> y3 >> x4 >> y4;
            s.emplace_back(x3);
            s.emplace_back(x4);
            t.emplace_back(x1, x4, y1, 1);
            t.emplace_back(x1, x4, y3, -1);
            t.emplace_back(x1, x3, y3, 1);
            t.emplace_back(x1, x3, y2, -1);
            t.emplace_back(x3, x2, y4, 1);
            t.emplace_back(x3, x2, y2, -1);
            t.emplace_back(x4, x2, y1, 1);
            t.emplace_back(x4, x2, y4, -1);
        }
        sort(s.begin(), s.end());
        sort(t.begin(), t.end());
        unique(s.begin(), s.end());
        ll ans = 0;
        st.build(1, 1, s.size());
        st.update(t[0].l, t[0].r, 1, t[0].val);
        mfor(i, 1, t.size() - 1)
        {
            //debug(t[i].p);
            ans += ((ll)t[i].p - t[i - 1].p) * st.getsum(1);
            //debug(ans);
            st.update(t[i].l, t[i].r, 1, t[i].val);
        }
        cout << ans << endl;
    }
    return 0;
}
```

# 格点问题

[248. 窗内的星星 - AcWing题库](https://www.acwing.com/problem/content/250/)

```cpp
#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<set>
#include<list>
#include<iomanip>
#include<cstring>
#include<cmath>
#include<limits>
#include<cctype>
#include<unordered_map>
#include<complex>
#include<assert.h>
#pragma warning(disable:4996)
using namespace std;

#define debug(i) cerr<<"<debug> "<<#i<<" "<<i<<" <\\debug>"<<endl
#define mfor(i,a,b) for(int i=(a);i<=(b);i++)
#define mrep(i,a,b) for(int i=(a);i>=(b);i--)
#define _for(i,a,b) for(ll i=(a);i<=(b);i++)
#define _rep(i,a,b) for(ll i=(a);i>=(b);i--)
#define lll __int128
#define Re register
#define mem(a,b) memset(a,(b),sizeof(a))
#define Design ios::sync_with_stdio(0),cin.tie(0),cout.tie(0)
#define endl '\n'
#define toang(x) ((x)*180.0/pi)	//转角度
#define torad(x) ((x)*pi/180.0)	//转弧度
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> intpair;
typedef pair<ll, ll> llpair;
typedef long double ld;
typedef double dl;
const ld pi = acos(-1.0);
const ld eps = 1e-5;
const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

const int maxn = 400010;

struct lin
{
    ll l, r;
    ll p;
    ll val;
    bool operator < (lin s)const
    {
        if (p == s.p) return val < s.val;
        return p < s.p;
    }
    lin(ll l, ll r, ll p, ll v) :l(l), r(r), p(p), val(v) {}
};

vector<ll>s;
vector<lin>t;

struct STtree
{
    //默认min add功能
    //query功能修改push_up cmp
    //update功能修改push_down update
    //greater功能修改greater
#define lc(x) x<<1
#define rc(x) x<<1|1
    struct tree
    {
        ll a;
        ll hl, hr;
        ll tag;
    }node[maxn << 2];

    inline void push_up(int x)
    {
        node[x].a = max(node[lc(x)].a, node[rc(x)].a) + node[x].tag;
    }

    void build(int x, int l, int r)
    {
        node[x].hl = s[l - 1];
        node[x].hr = s[r - 1];
        node[x].tag = 0;
        node[x].a = 0;
        if (r - l <= 1) return;
        int mid = (l + r) >> 1;
        build(lc(x), l, mid);
        build(rc(x), mid, r);
        push_up(x);
    }

    void update(ll left, ll right, int x, ll k)
    {
        if (left <= node[x].hl && node[x].hr <= right)
        {
            node[x].tag += k;
            node[x].a += k;
            push_up(x);
            return;
        }
        if (left < node[lc(x)].hr) update(left, right, lc(x), k);
        if (right > node[rc(x)].hl) update(left, right, rc(x), k);
        push_up(x);
    }

    ll getsum(int x)
    {
        return node[x].a;
    }

}st;

int main()
{
    Design;
    int n;
    ll w, h;
    while (cin >> n >> w >> h)
    {
        s.clear();
        t.clear();
        mfor(i, 1, n)
        {
            ll x, y, v;
            cin >> x >> y >> v;
            s.emplace_back(x);
            s.emplace_back(x + w);
            t.emplace_back(x, x + w, y, v);
            t.emplace_back(x, x + w, y + h, -v);
        }
        sort(s.begin(), s.end());
        unique(s.begin(), s.end());
        sort(t.begin(), t.end());
        st.build(1, 1, s.size());
        ll ans = 0;
        mfor(i, 0, (int)t.size() - 1)
        {
            st.update(t[i].l, t[i].r, 1, t[i].val);
            ans = max(ans, st.getsum(1));
        }
        cout << ans << endl;
    }
    return 0;
}
```

