```cpp
ll la[200010];
ll lb[200010];  //x≡lb(mod la)

ll fpow(ll a, ll n, ll mod)
{
    if (n == 0)        return 1;
    else if (n & 1) return a * fpow(a, n - 1, mod) % mod;
    else
    {
        ll num = fpow(a, n / 2, mod) % mod;
        return num * num % mod;
    }
}

ll exgcd(ll a, ll b, ll& x, ll& y)
{
    if (!b)
    {
        x = 1;
        y = 0;
        return a;
    }
    ll t = exgcd(b, a % b, y, x);
    y -= x * (a / b);
    return t;
}

ll get(ll a, ll mod)	//a在模mod下的乘法逆元
{
    ll x = 0;
    ll y = 0;
    exgcd(a, mod, x, y);
    return (x % mod + mod) % mod;
}

ll calm(ll a, ll mod, ll p) 
{
    if (!a) return 1;
    ll len = 1;//循环节
    ll rem = 1;//余项 
    for (ll i = 1; i <= p; i++) 
    {
        if (i % mod) len = len * i % p;
    }
    len = fpow(len, a / p, p);
    for (ll i = p * (a / p); i <= a; i++) 
    {
        if (i % mod) rem = rem * (i % p) % p;
    }
    return calm(a / mod, mod, p) * len % p * rem % p;
}

ll cx(ll a, ll mod) 
{
    if (a < mod) return 0;
    return cx(a / mod, mod) + (a / mod);
}

ll comt(ll n, ll m, ll mod, ll p) 
{
    ll fz = calm(n, mod, p);
    ll fm1 = get(calm(m, mod, p), p);
    ll fm2 = get(calm(n - m, mod, p), p);
    ll mi = fpow(mod, cx(n, mod) - cx(m, mod) - cx(n - m, mod), p);
    return fz * fm1 % p * fm2 % p * mi % p;
}

ll exlucas(ll n, ll m, ll mod)
{//计算C(n,m)%mod，与lucas的区别在于mod可以不是质数
 //多次使用无需重新初始化
    ll x = mod;
    int cnt = 0;
    for (ll i = 2; i * i <= mod; i++)
    {
        if (!(x % i))
        {
            ll t = 1;
            while (x % i == 0)
            {
                t *= i;
                x /= i;
            }
            la[++cnt] = t;
            lb[cnt] = comt(n, m, i, t);
        }
    }
    if (x > 1)
    {
        la[++cnt] = x;
        lb[cnt] = comt(n, m, x, x);
    }
    ll res = 0;
    for (ll i = 1; i <= cnt; i++)
    {
        ll m = mod / la[i];
        res = (res + lb[i] * m % mod * get(m, la[i]) % mod) % mod;
    }
    return res;
}
```

