```cpp
//使用通项式在 O(mlogn) 复杂度下计算出 S(n,m)

ll fpow(ll a, ll n, ll mod)
{
    ll res = 1;
    while (n)
    {
        if (n & 1)
        {
            res = res % mod * a % mod;
        }
        a = a % mod * a % mod;
        n >>= 1;
    }
    return res;
}

ll fac[1000010];
ll inv[1000010];

ll com(ll a, ll b, ll mod)
{
    //计算组合数
    if (a < b) return 0;
    return fac[a] * inv[b] % mod * inv[a - b] % mod;
}

void getfacinv(int n, ll mod)
{//初始化fac和inv数组，获取1!-n!和相应的逆元
    fac[0] = inv[0] = 1;
    for (int i = 1; i <= n; i++) fac[i] = fac[i - 1] * i % mod;
    inv[n] = fpow(fac[n], mod - 2, mod);
    for (int i = n - 1; i >= 1; i--) inv[i] = inv[i + 1] * (i + 1LL) % mod;
}

ll stirling2(ll n, ll m, ll mod)
{//S(n,m)
    if (!fac[1]) getfacinv(1e6, mod);
    ll res = inv[m];
    ll t = 0;
    mfor(i, 0, m)
    {
        ll f = (i & 1 ? -1 : 1);
        t += f * com(m, i, mod) * fpow(m - i, n, mod) % mod;
        t %= mod;
        t += mod;
        t %= mod;
    }
    res *= t;
    res %= mod;
    return res;
}
```

