```cpp
int n, m;
const int maxn = 50010;

struct Node
{
	int l, r, u, d;
	int row, col;
}node[maxn];

int head[maxn];
int tot[maxn];	//每列节点数
int cnt;	//总节点数
int ans;
int ansk[maxn];	//选中的行

void init()
{
	mfor(i, 0, m)
	{
		node[i].r = i + 1;
		node[i].l = i - 1;
		node[i].u = i;
		node[i].d = i;
	}
	node[m].r = 0;
	node[0].l = 0;
	memset(head, -1, sizeof(head));
	cnt = m + 1;	//初始节点数为0节点和各列头节点
}

void insert(int x, int y) //点(x,y)变成1
{
	tot[y]++;
	node[cnt].col = y;
	node[cnt].row = x;
	node[cnt].u = y;
	node[cnt].d = node[y].d;
	node[node[y].d].u = cnt;
	node[y].d = cnt;
	if (!~head[x]) head[x] = node[cnt].l = node[cnt].r = cnt;
	else
	{
		node[cnt].r = head[x];
		node[cnt].l = node[head[x]].l;
		node[node[head[x]].l].r = cnt;
		node[head[x]].l = cnt;
	}
	cnt++;
}

void remove(int x)
{
	node[node[x].l].r = node[x].r;
	node[node[x].r].l = node[x].l;
	for (int i = node[x].d; i != x; i = node[i].d)
	{
		for (int j = node[i].r; j != i; j = node[j].r)
		{
			node[node[j].d].u = node[j].u;
			node[node[j].u].d = node[j].d;
			tot[node[j].col]--;
		}
	}
}

void resume(int x)
{
	for (int i = node[x].u; i != x; i = node[i].u)
	{
		for (int j = node[i].l; j != i; j = node[j].l) 
		{
			node[node[j].d].u = j;
			node[node[j].u].d = j;
			tot[node[j].col]++;
		}
	}
	node[node[x].l].r = x;
	node[node[x].r].l = x;
}

bool dance(int d)
{
	if (!node[0].r)
	{
		ans = d;
		//可在此保存具体解（用ansk还原出选择的行构成的矩阵）
		return true;//多解无此行
	}
	int x = node[0].r;
	for (int i = node[0].r; i != 0; i = node[i].r)
	{
		if (tot[i] < tot[x]) x = i;//找到1最少的列
	}
	remove(x);
	for (int i = node[x].d; i != x; i = node[i].d)
	{
		ansk[d + 1] = node[i].row;
		for (int j = node[i].r; j != i; j = node[j].r) remove(node[j].col);
		if (dance(d + 1)) return true;
		for (int j = node[i].l; j != i; j = node[j].l) resume(node[j].col);
	}
	resume(x);
	return false;
}

int main()
{
	Design;
	cin >> n >> m;
	init();
	mfor(i, 1, n)
	{
		mfor(j, 1, m)
		{
			bool t;
			cin >> t;
			if (t) insert(i, j);
		}
	}
	if (!dance(0)) cout << "No Solution!";
	else
	{
		mfor(i, 1, ans) cout << ansk[i] << " ";
	}
}
```

