```cpp
ll imul;
ll mod;

struct complex
{
	ll rel, img;
	complex(ll x = 0, ll y = 0) :rel(x), img(y) {}
	bool operator == (complex s)
	{
		return rel == s.rel && img == s.img;
	}
	complex operator * (complex s)
	{
		return complex((rel * s.rel + imul * img % mod * s.img) % mod, (img * s.rel + rel * s.img) % mod);
	}
};

complex power(complex a, ll n)
{
    //虚数快速幂
	complex res = 1;
	while (n)
	{
		if (n & 1) res = res * a;
		a = a * a;
		n >>= 1;
	}
	return res;
}
```